MKFIFOAT(3)

NAME
mkfifoat - make a FIFO (named pipe) relative to a directory file descriptor

SYNOPSIS
#define _ATFILE_SOURCE
#include <sys/stat.h>

int mkfifoat(int dirfd, const char *pathname, mode_t mode);

DESCRIPTION
The mkfifoat() system call operates in exactly the same way as mkfifo(3), except for the differences described in this manual page. If the pathname given in pathname is relative, then it is interpreted relative to the directory referred to by the file descriptor dirfd (rather than relative to the current working directory of the calling process, as is done by mkfifo(3) for a relative pathname). If pathname is relative and dirfd is the special value AT_FDCWD, then pathname is interpreted relative to the current working directory of the calling process (like mkfifo(3)). If pathname is absolute, then dirfd is ignored.

RETURN VALUE
On success, mkfifoat() returns 0. On error, -1 is returned and errno is set to indicate the error.

ERRORS
The same errors that occur for mkfifo(3) can also occur for mkfifoat(). The following additional errors can occur for mkfifoat():

EBADF
    dirfd is not a valid file descriptor.

ENOTDIR
    pathname is a relative path and dirfd is a file descriptor referring to a file other than a directory.

VERSIONS
mkfifoat() was added to glibc in version 2.4. It is implemented using mknod(2), available on Linux since kernel 2.6.16.

CONFORMING TO
This function is non-standard but is proposed for inclusion in a future revision of POSIX.1.

NOTES
See openat(2) for an explanation of the need for mkfifoat().

SEE ALSO
openat(2), mkfifo(3), path_resolution(7)